=== modified file 'mpregen'
--- mpregen	2007-04-11 17:50:52 +0000
+++ mpregen	2007-04-11 20:03:40 +0000
@@ -22,11 +22,11 @@
 file_id = wt.path2id(path)
 file_weave = wt.branch.repository.get_inventory_weave()
 #file_weave = bt.get_weave(file_id)
-file_weave.enable_cache()
+#file_weave.enable_cache()
 revisions = set(file_weave.versions())
 ft_set = set(r for r in revisions if file_weave._index.get_method(r)
              == 'fulltext')
-vf = MultiVersionedFile(None)
+vf = MultiVersionedFile(25)
 #files = {}
 #for version_id in revisions:
 #    lines = [a + ' ' + l for a, l in file_weave.annotate_iter(version_id)]
@@ -40,8 +40,9 @@
         if [p for p in parents if p not in vf._diffs] != []:
             continue
         lines = file_weave.get_lines(revision)
-        vf.add_version(lines, revision, parents,
-                       force_snapshot=(revision in ft_set))
+#        vf.add_version(lines, revision, parents,
+#                       force_snapshot=(revision in ft_set))
+        vf.add_version(lines, revision, parents)
         added.add(revision)
         vf.clear_cache()
     revisions = [r for r in revisions if r not in added]

=== modified file 'multiparent/__init__.py'
--- multiparent/__init__.py	2007-04-11 17:50:52 +0000
+++ multiparent/__init__.py	2007-04-11 20:03:40 +0000
@@ -182,10 +182,11 @@
         for ignored in xrange(self.snapshot_interval):
             if len(parent_ids) == 0:
                 return False
-            version_id = parent_ids[0]
-            if version_id in self._snapshots:
-                return False
-            parent_ids = self._parents[version_id]
+            version_ids = parent_ids
+            parent_ids = []
+            for version_id in version_ids:
+                if version_id not in self._snapshots:
+                    parent_ids.extend(self._parents[version_id])
         else:
             return True
 
@@ -221,7 +222,8 @@
             pass
         diff = self._diffs[version_id]
         lines = []
-        reconstructor = _Reconstructor(self._diffs, self._lines, self._parents)
+        reconstructor = _Reconstructor(self._diffs, self._lines,
+                                       self._parents)
         reconstructor.reconstruct_version(lines, version_id)
         self._lines[version_id] = lines
         return lines
@@ -240,7 +242,8 @@
         """Append the lines referred to by a ParentText to lines"""
         parent_id = self.parents[version_id][parent_text.parent]
         end = parent_text.parent_pos + parent_text.num_lines
-        return self._reconstruct(lines, parent_id, parent_text.parent_pos, end)
+        return self._reconstruct(lines, parent_id, parent_text.parent_pos,
+                                 end)
 
     def _reconstruct(self, lines, req_version_id, req_start, req_end):
         """Append lines for the requested version_id range"""

